function output_data = MAP(input_data)
%%% Input
% input_data structure
%%% Output 
% output_data structure
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% calculate initial reflector of initialGuess over magnitude constraint
x    = input_data.initialGuess;
k = 1;
output_data.error = zeros(input_data.algorithm.maxit);
error = inf;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
while ( k < input_data.algorithm.maxit && error > input_data.algorithm.error )
  
    gamma = computeShrinkageParameter(input_data, k);
    tmp1  = magnitudeProjection( input_data, x);
    x_old = x;
    x     = constraintProximityOperator(input_data, tmp1, gamma);
     
    error = computeError(input_data, x, x_old, tmp1);
        
    output_data.error(k) = error;
    k = k+1;
    itMsg = sprintf('Iteration: %d, Gamma: %.6f, Error: %.3f, Constraint: %s', k, gamma, error, input_data.problem.constraint.name);
    disp(itMsg);
end

output_data.error = output_data.error(1:k-1);
output_data.reconstruction = x;