function outputWave = magnitudeProjection( input_data, Psi )
%MAGNITUDEPROJECTION Calculates the projection onto a magnitude
%   constraint set.
% Input:
%   input_data - structure containing all input data
%   Psi        - function to be projected, usually the iterate of some
%                   algorithm
% Output:
%   outputWave - the wave function projected onto the magnitude set

propagatedWave = wavePropagator(input_data, Psi, 1);
projectedWave = MagProj(input_data.problem.data, propagatedWave);
outputWave = wavePropagator(input_data, projectedWave, -1);

end

