function [ output_args ] = plotReconstructionResults( rec1, rec2, rec3, rec4 )
%PLOTRECONSTRUCTIONRESULTS Plots up to four different reconstructions.
%   Input: The reconstruction structures (up to at most four)
%   Output: Plots

if nargin == 1
    figure(1)
        plot(rec1.error);
        title('Error decay')
        xlabel('Iteration')
        ylabel('Error')
        legend(rec1.problem.constraint.name)
        if isfield(rec1.problem.constraint, 'info')
            legend(strcat(rec1.problem.constraint.name, ' (',rec1.problem.constraint.info, ')'))
        end
    figure(2)
    if strcmp(rec1.problem.type, 'amplitude')
        imagesc(abs(rec1.reconstruction))
        
    elseif strcmp(rec1.problem.type, 'phase')
        imagesc(angle(rec1.reconstruction))
        
    end
    if isfield(rec1.problem.constraint, 'info')        
            title(strcat('Reconstruction: ', rec1.problem.constraint.name, ' (', rec1.problem.constraint.info, ')'))
    else
            title(strcat('Reconstruction: ', rec1.problem.constraint.name))
    end
end

if nargin >= 2
   
    figure(1)
    subplot(nargin,1,1); 
        plot(rec1.error);
        title('Error decay')
        xlabel('Iteration')
        ylabel('Error')
        legend(rec1.problem.constraint.name)
        if isfield(rec1.problem.constraint, 'info')
            legend(strcat(rec1.problem.constraint.name, ' (',rec1.problem.constraint.info, ')'))
        end
      
    subplot(nargin,1,2); 
        plot(rec2.error);
        title('Error decay')
        ylabel('Error')
        xlabel('Iteration')
        legend(rec2.problem.constraint.name)
        if isfield(rec2.problem.constraint, 'info')
            legend(strcat(rec2.problem.constraint.name, ' (',rec2.problem.constraint.info, ')'))
        end        
        
    if nargin >= 3
        subplot(nargin,1,3); 
            plot(rec3.error);
            title('Error decay')
            ylabel('Error')
            xlabel('Iteration')
            legend(rec3.problem.constraint.name)        
            if isfield(rec3.problem.constraint, 'info')
                legend(strcat(rec3.problem.constraint.name, ' (',rec3.problem.constraint.info, ')'))
            end
    end
    
    if nargin == 4
       subplot(nargin,1,4); 
          plot(rec4.error);
          title('Error decay')
          ylabel('Error')
          xlabel('Iteration')
          legend(rec4.problem.constraint.name)
          if isfield(rec4.problem.constraint, 'info')
            legend(strcat(rec4.problem.constraint.name, ' (',rec4.problem.constraint.info, ')'))
          end
    end
    
    figure(2)
    
        subplot(nargin,1,1); 
        if strcmp(rec1.problem.type, 'amplitude')
            imagesc(abs(rec1.reconstruction))
        elseif strcmp(rec1.problem.type, 'phase')
            imagesc(angle(rec1.reconstruction))
        end
        if isfield(rec1.problem.constraint, 'info')        
            title(strcat('Reconstruction: ', rec1.problem.constraint.name, ' (', rec1.problem.constraint.info, ')'))
        else
            title(strcat('Reconstruction: ', rec1.problem.constraint.name))
        end
      
    subplot(nargin,1,2); 
        if strcmp(rec2.problem.type, 'amplitude')
             imagesc(abs(rec2.reconstruction))
        elseif strcmp(rec2.problem.type, 'phase')
            imagesc(angle(rec2.reconstruction))
        end
        if isfield(rec2.problem.constraint, 'info')        
            title(strcat('Reconstruction: ', rec2.problem.constraint.name, ' (', rec2.problem.constraint.info, ')'))
        else
            title(strcat('Reconstruction: ', rec2.problem.constraint.name))
        end
        
    if nargin >= 3
      subplot(nargin,1,3)
       if strcmp(rec3.problem.type, 'amplitude')
         imagesc(abs(rec3.reconstruction))
       elseif strcmp(rec3.problem.type, 'phase')
         imagesc(angle(rec3.reconstruction))
       end
       if isfield(rec3.problem.constraint, 'info')        
          title(strcat('Reconstruction: ', rec3.problem.constraint.name, ' (', rec3.problem.constraint.info, ')'))
       else
          title(strcat('Reconstruction: ', rec3.problem.constraint.name))
       end
    end
    
    if nargin == 4
       subplot(nargin,1,4); 
        if strcmp(rec4.problem.type, 'amplitude')
            imagesc(abs(rec4.reconstruction))
        elseif strcmp(rec4.problem.type, 'phase')
            imagesc(angle(rec4.reconstruction))
        end
        if isfield(rec1.problem.constraint, 'info')        
            title(strcat('Reconstruction: ', rec1.problem.constraint.name, ' (', rec1.problem.constraint.info, ')'))
        else
            title(strcat('Reconstruction: ', rec1.problem.constraint.name))
        end
    end
    
end

end

