function proximityOperatorName = retrieveProximityName( input_data )
%RETRIEVEPROXIMITYNAME A dirty little hack to improve simplicity
%   of evaluation of proximity operators. Given the specified
%   constraint name in the input_data object, the correct name
%   for the MATLAB function which contains the corresponding
%   proximity operator is returned as a string. This is hard-coded
%   here and can be extended to your liking.

if ~isfield(input_data.problem.constraint, 'name')
    error('No constraint name defined.')
end

if ( strcmp(input_data.problem.constraint.name, 'shearlet thresholding') || strcmp(input_data.problem.constraint.name, 'shearlet thresholding and range') )
           
    proximityOperatorName = 'proxShearlet';
            
elseif strcmp(input_data.problem.constraint.name, 'support')
        
    proximityOperatorName = 'proxSupportConstraint';
        
elseif strcmp(input_data.problem.constraint.name, 'range')
    
    proximityOperatorName = 'proxRangeConstraint';

elseif strcmp(input_data.problem.constraint.name, 'support and range')
    
    proximityOperatorName = 'proxSupportRangeConstraint';
          
end

if ~exist('proximityOperatorName', 'var')
    error('The provided constraint name ''%s'' is not supported. Check retrieveProximityName.m for details.', input_data.problem.constraint.name);
end


end

